## botch 0.4

=== Makefile ===
VERSION=0.4

BIN_OPT:= \
  create-graph.native \
  print-stats.native \
  bin2src.native \
  src2bin.native \
  build-fixpoint.native \
  build-closure.native \
  clean-repository.native \
  buildgraph2srcgraph.native \
  annotate-strong.native \
  partial-order.native \
  find-fvs.native \
  collapse-srcgraph.native \
  optuniv.native \
  calculate-fas.native

BIN_BYTE:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))

BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py,$(wildcard tools/*.py)))
BIN_OCTOOLS:=$(patsubst %.native, %, $(BIN_OPT))
BIN_SHTOOLS:=$(patsubst tools/%.sh, %, $(wildcard tools/*.sh))

BIN_TOOLS:=$(BIN_PYTOOLS) $(BIN_OCTOOLS) $(BIN_SHTOOLS)
MANPAGES:=$(patsubst %, doc/man/botch-%.1, $(BIN_TOOLS))

OCAML_BEST ?= $(if $(wildcard /usr/bin/ocamlopt),native,d.byte)

PWD := $(shell pwd)
BUILD = $(PWD)/dose/_build
DOSELIBS = $(PWD)/dose/_build/dose3
CUDFLIBS = $(PWD)/dose/_build/cudf
DOSEBYTELIBS = common/common.cma deb/debian.cma rpm/rpm.cma opencsw/csw.cma eclipse/eclipse.cma algo/algo.cma doseparse/boilerplateNoRpm.cma doseparse/boilerplate.cma
CFLAGS=-cflags "-w +a-4-9"
bindir=/usr/bin
datadir=/usr/share/botch

# we have to export PYTHONHASHSEED because otherwise networkx will create
# content with random output order
#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=749710
#   https://github.com/networkx/networkx/issues/1181
export PYTHONHASHSEED=0
# to make the sort order in the tests locale independent
export LC_COLLATE=C
# because cross-problems outputs utf8 on standard output
export PYTHONIOENCODING=utf-8

.PHONY: all
all: $(OCAML_BEST) doc

.PHONY: native
native: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_OPT)

.PHONY: d.byte
d.byte: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_BYTE)

# profiling for use of native executables with gprof
.PHONY: profile
profile: atdgen
	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_PROF)

.PHONY: doc
doc: $(MANPAGES)
	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > ./doc/man/botch.1
	$(MAKE) -C doc/wiki

doc/man/%.1: doc/man/%.pod
	pod2man --section 1 --center="botch tools" $< > $@

.PHONY: doselib
doselib:
	(cd dose && ./configure --with-zip --with-bz2 --with-ocamlgraph --without-libcudf && make clean fast $(DOSEBYTELIBS))
	rm -Rf $(DOSELIBS)
	mkdir -p $(DOSELIBS)
	cp dose/META $(DOSELIBS)
	for i in dose/_build/*/common.* \
		dose/_build/*/debian.* \
		dose/_build/*/algo.* \
		dose/_build/*/csw.* \
		dose/_build/*/eclipse.* \
		dose/_build/*/boilerplate.* \
		dose/_build/*/boilerplateNoRpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done
	rm -Rf $(CUDFLIBS)
	mkdir -p $(CUDFLIBS)
	cp dose/cudf/META $(CUDFLIBS)
	cp dose/_build/doselibs/cudf*.cmi $(CUDFLIBS)
	for i in dose/_build/doselibs/cudf.*; do \
	  if [ -e $$i ]; then \
	    cp $$i $(CUDFLIBS) ; \
	    rm -f $(CUDFLIBS)/*.mlpack $(CUDFLIBS)/*.cmx ; \
	  fi ; \
	done

%_j.ml: %.atd
	atdgen -j -j-std $<

%_t.ml: %.atd
	atdgen -t $<

.PHONY: atdgen
atdgen: datatypes_j.ml datatypes_t.ml

.PHONY: test-default
test-default: all
	rm -rf tmp out
	./tools/native.sh --debug --verbose --develop --output out --tmp tmp amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
	for f in tests/default/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
			*) diff -u "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
		esac; \
	done
	for f in tests/default/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/default/out/$$f" "out/$$f" || exit 1;; \
			*) diff -u "tests/default/out/$$f" "out/$$f" || exit 1;; \
		esac; \
	done

.PHONY: test-selfcontained
test-selfcontained: all
	rm -rf tmp out
	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --latest --clean --self-contained --optuniv --sapsb --strong --no-drop amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
	for f in tests/selfcontained/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
			*) diff -u "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
		esac; \
	done
	for f in tests/selfcontained/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
			*) diff -u "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
		esac; \
	done

.PHONY: test-cross
test-cross: all
	rm -rf tmp out
	mkdir out
	cp tests/cross-ma.diff out/ma.diff
	./tools/cross.sh --debug --verbose --develop --output=out --tmp=tmp amd64 armhf tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
	for f in tests/cross/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
			*) diff -u "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
		esac; \
	done
	for f in tests/cross/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
		echo checking $$f; \
		case "$$f" in \
			*.xml) ./tools/graph-difference.py "tests/cross/out/$$f" "out/$$f" || exit 1;; \
			*) diff -u "tests/cross/out/$$f" "out/$$f" || exit 1;; \
		esac; \
	done

.PHONY: test
test: test-default test-selfcontained test-cross
	# test whether there is no manpage without a program by
	# normalizing program and manpage names and only printing
	# those names which are not duplicate but unique
	ls tools/*.py *.$(OCAML_BEST) tools/*.sh doc/man/botch-*.pod \
		| grep -v tools/util.py \
		| while read pkg; do \
			pkg=`basename $$pkg .$(OCAML_BEST)`; \
			pkg=`basename $$pkg .py`; \
			pkg=`basename $$pkg .sh`; \
			pkg=`basename $$pkg .pod`; \
			echo $${pkg#botch-}; \
		done | sort | uniq -u | while read pkg; do \
			echo doc/man/botch-$${pkg}.pod is superfluous >&2; \
			exit 1; \
		done
	# FIXME: add more tests
	#./tests.py
	#OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) tests.$(OCAML_BEST)
	#./tests.$(OCAML_BEST)
	pyflakes3 tools/*.py
	pep8 tools/*.py

.PHONY: install
install: all
	$(MAKE) -C doc/wiki install
	mkdir -p $(DESTDIR)$(bindir)
	for octool in $(BIN_OCTOOLS); do \
		cp _build/$$octool.$(OCAML_BEST) $(DESTDIR)$(bindir)/botch-$$octool; \
	done
	for shtool in $(BIN_SHTOOLS); do \
		cp tools/$$shtool.sh $(DESTDIR)$(bindir)/botch-$$shtool; \
	done
	for pytool in $(BIN_PYTOOLS); do \
		cp tools/$$pytool.py $(DESTDIR)$(bindir)/botch-$$pytool; \
	done
	mkdir -p $(DESTDIR)$(datadir)
	cp -r droppable $(DESTDIR)$(datadir)
	cp tools/util.py $(DESTDIR)$(datadir)

.PHONY: clean
clean:
	ocamlbuild -clean
	rm -f datatypes_j.ml datatypes_j.mli datatypes.ml datatypes.mli datatypes_t.ml datatypes_t.mli
	rm -f tools/*.pyc
	rm -f *.native *.d.byte
	rm -f doc/man/*.1
	rm -rf tools/__pycache__ tmp out
	$(MAKE) -C doc/wiki clean

.PHONY: doseclean
doseclean:
	(cd dose && ocamlbuild -clean)

.PHONY: tarball
tarball:
	$(eval tmpdir := $(shell mktemp --directory))
	git archive --worktree-attributes --prefix=botch-$(VERSION)/ -o $(tmpdir)/botch-$(VERSION).tar HEAD
	git -C doc/wiki archive --worktree-attributes --prefix=botch-$(VERSION)/doc/wiki/ -o $(tmpdir)/botch-doc.tar HEAD
	git -C tests archive --worktree-attributes --prefix=botch-$(VERSION)/tests/ -o $(tmpdir)/botch-tests.tar HEAD
	# tar --concatenate seems to only take two files as input so we can
	# neither replace the temporary files with a pipe nor combine both of
	# the below commands into one... :(
	tar --concatenate -f $(tmpdir)/botch-$(VERSION).tar $(tmpdir)/botch-doc.tar
	tar --concatenate -f $(tmpdir)/botch-$(VERSION).tar $(tmpdir)/botch-tests.tar
	# testing shows that in this case, -9e compresses better than -9
	xz --verbose -c9e $(tmpdir)/botch-$(VERSION).tar > ../botch-$(VERSION).tar.xz
	rm -rf $(tmpdir)

.PHONY: upload
upload: tarball
	gpg -u 8FBD83E1 --armor --detach-sig ../botch-$(VERSION).tar.xz
	scp ../botch-$(VERSION).tar.xz.asc ../botch-$(VERSION).tar.xz mmfn:/var/www/botch/
	ssh mmfn tree -s --noreport -P "botch-*.tar.xz*" -o /var/www/botch/index.html -v -L 1 -H "." -T "botch-releases" /var/www/botch/

=== doc/wiki/Makefile ===
md=$(wildcard *.markdown)
html=$(patsubst %.markdown,%.html,$(md))
dot=$(wildcard *.dot)
png=$(patsubst %.dot,%.png,$(dot))
docdir=/usr/share/doc/botch

.PHONY: all
all: $(html) $(png)

%.html: %.markdown
	sed 's/\[\[\([^]]\+\)\]\]/<a href="\1.html">\1<\/a>/' $< | markdown > $@

%.png: %.dot
	dot -T png $< > $@

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(docdir)/wiki
	cp $(html) $(png) $(DESTDIR)$(docdir)/wiki

.PHONY: clean
clean:
	rm -f $(html) $(png)

=== debian/changelog ===
botch (0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Tue, 14 Oct 2014 01:26:25 +0200

botch (0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Sun, 12 Oct 2014 08:51:01 +0200

botch (0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Johannes Schauer <j.schauer@email.de>  Sun, 12 Oct 2014 02:03:02 +0200

botch (0.1-1) unstable; urgency=medium

  * Initial release. (Closes: #748102)

 -- Johannes Schauer <j.schauer@email.de>  Wed, 14 May 2014 11:54:59 +0200

=== debian/control ===
Source: botch
Section: utils
Priority: extra
Maintainer: Johannes Schauer <j.schauer@email.de>
Homepage: https://gitorious.org/debian-bootstrap/pages/Home
Standards-Version: 3.9.5
# all build dependencies after the *-dev dependencies are only needed to run
# the testsuite
Build-Depends:
 debhelper (>= 9),
 ocaml-nox,
 camlp4,
 python3,
 graphviz,
 markdown,
 ocaml-findlib,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev,
 libatdgen-ocaml-dev,
 libxmlm-ocaml-dev,
 libdose3-ocaml-dev (>= 3.2.2),
 dose-builddebcheck (>= 3.2.2),
 dose-extra (>= 3.2.2),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml,
 pep8,
 pyflakes
XS-Testsuite: autopkgtest

Package: botch
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 dose-builddebcheck (>= 3.2.2),
 dose-extra (>= 3.2.2),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml
# libjs-jquery-tablesorter and libjs-jquery are needed to look at the generated
# HTML with javascript bling
Recommends:
 libjs-jquery-tablesorter,
 libjs-jquery
# devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
# needed by botch-cross-problems because there is no soap module for python3
Suggests:
 devscripts,
 libsoap-lite-perl
Description: Bootstrapping helper
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 It includes a range of utilities to:
 .
  - transform Packages and Sources control files
      - set operations (union, intersection, difference)
      - adding and removing specific metadata
      - only pick latest version
      - Packages to Sources
      - Sources to Packages
      - generating self contained repositories (min and max)
  - analysis of Packages and Sources control files
      - diff tool
      - multiarch changes application
      - check multi-arch:same versions
  - create graphs of different types
      - installation sets
      - strong dependency sets
      - dependency closure
  - conversion of graphs
      - buildgraph to source graph
      - graphml to dot format
      - annotation with strong dependency information
      - extract neighborhood
      - extract strongly connected components
      - collapsing strongly connected components
  - analyze graphs
      - find all cycles
      - find selfcycles
      - find amount of cycles through edges
      - find feedback arc set
      - find feedback vertex set
      - find strong articulation points and strong bridges
      - general graph info
      - generating partial order
      - graph rendering
      - graph difference
      - calculate betweenness
      - calculate port metric
  - shell scripts connecting the tools for meaningful operations
      - analyzing cross bootstrap phase
      - analyzing native bootstrap phase
      - create a transition order

Package: botch-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends:
Suggests:
Description: Bootstrapping helper - documentation
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
OCAML_DEP=
else
OCAML_DEP=ocaml-base-nox-$(shell ocamlc -version)
endif

%:
	dh $@ --with python3

# not stripping binaries as this will lead to random segfaults
override_dh_strip:

override_dh_gencontrol:
	dh_gencontrol -- -Vocaml:Depends=$(OCAML_DEP)

## botch 0.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.4
+VERSION=0.6
 
 BIN_OPT:= \
   create-graph.native \
@@ -14,7 +14,9 @@
   find-fvs.native \
   collapse-srcgraph.native \
   optuniv.native \
-  calculate-fas.native
+  calculate-fas.native \
+  buildcheck-more-problems.native \
+  distcheck-more-problems.native
 
 BIN_BYTE:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
 BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))
@@ -41,10 +43,13 @@
 # content with random output order
 #   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=749710
 #   https://github.com/networkx/networkx/issues/1181
+# on the other hand, the generated hashes are not the same on 32 vs 64 arches
+#   http://bugs.python.org/issue22621
+#   http://bugs.debian.org/778373
 export PYTHONHASHSEED=0
 # to make the sort order in the tests locale independent
 export LC_COLLATE=C
-# because cross-problems outputs utf8 on standard output
+# because dose2html outputs utf8 on standard output
 export PYTHONIOENCODING=utf-8
 
 .PHONY: all
@@ -63,9 +68,11 @@
 profile: atdgen
 	OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) $(BIN_PROF)
 
+doc/man/botch.1: $(MANPAGES)
+	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > $@
+
 .PHONY: doc
-doc: $(MANPAGES)
-	./doc/man/generate-botch-manpage.py | pod2man --section 1 --center="botch tools" --name botch > ./doc/man/botch.1
+doc: $(MANPAGES) doc/man/botch.1
 	$(MAKE) -C doc/wiki
 
 doc/man/%.1: doc/man/%.pod

=== debian/changelog ===
botch (0.6-1~experimental3) experimental; urgency=medium

  * add patch send-keepalive to not abort build on arches without ocamlopt

 -- Johannes Schauer <josch@debian.org>  Sun, 15 Feb 2015 09:55:37 +0100

botch (0.6-1~experimental2) experimental; urgency=medium

  * do not explicitly set `dh_gencontrol -- -Vocaml:Depends` already done by
    dh-ocaml
  * do not run test suite without ocamlopt as that will make the build get
    killed by a timeout (closes: #778449)
  * add dh --with ocaml
  * include /usr/share/ocaml/ocamlvars.mk for OCAML_HAVE_OCAMLOPT
  * Build-Depend on dh-ocaml
  * add lintian overrides for hardening and strip errors

 -- Johannes Schauer <josch@debian.org>  Sun, 15 Feb 2015 08:04:35 +0100

botch (0.6-1~experimental1) experimental; urgency=medium

  * New upstream release (closes: #778373)

 -- Johannes Schauer <josch@debian.org>  Sat, 14 Feb 2015 10:56:50 +0100

botch (0.5-1~experimental3) experimental; urgency=medium

  * this upload removes the build-dependency on python3-yaml:native and the
    dependency on python3-yaml:amd64 to make it compilable/installable again

 -- Johannes Schauer <josch@debian.org>  Thu, 12 Feb 2015 10:57:05 +0100

botch (0.5-1~experimental2) experimental; urgency=medium

  * making an upload to experimental

 -- Johannes Schauer <josch@debian.org>  Fri, 06 Feb 2015 10:45:02 +0100

botch (0.5-1~experimental1) unstable; urgency=medium

  * New upstream release.
    - graph comparison is now done using botch-graph-difference
      (Closes: #764909)
    - adjusted to build with latest dose 3.3 (Closes: #770613)
  * bump dependency on dose lib and tools to 3.3
  * adjust autopkgtests to use botch-graph-difference to compare graphs
  * bump Standards-Version to 3.9.6
  * botch now suggests www-browser because some of its output is HTML
  * change my email in Maintainer field to josch@debian.org
  * add Vcs-Browser and Vcs-Git fields
  * change priority from extra to optional because it has no conflicts and is
    not a debug package
  * add build dependency on python3-yaml:native and dependency on
    python3-yaml:amd64 for testing purposes - please revert!

 -- Johannes Schauer <josch@debian.org>  Fri, 06 Feb 2015 07:26:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: botch
 Section: utils
-Priority: extra
-Maintainer: Johannes Schauer <j.schauer@email.de>
+Priority: optional
+Maintainer: Johannes Schauer <josch@debian.org>
 Homepage: https://gitorious.org/debian-bootstrap/pages/Home
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 # all build dependencies after the *-dev dependencies are only needed to run
 # the testsuite
 Build-Depends:
  debhelper (>= 9),
+ dh-ocaml,
  ocaml-nox,
  camlp4,
  python3,
@@ -18,9 +19,9 @@
  libocamlgraph-ocaml-dev,
  libatdgen-ocaml-dev,
  libxmlm-ocaml-dev,
- libdose3-ocaml-dev (>= 3.2.2),
- dose-builddebcheck (>= 3.2.2),
- dose-extra (>= 3.2.2),
+ libdose3-ocaml-dev (>= 3.3),
+ dose-builddebcheck (>= 3.3),
+ dose-extra (>= 3.3),
  dctrl-tools,
  aspcud,
  python3-apt,
@@ -30,6 +31,8 @@
  pep8,
  pyflakes
 XS-Testsuite: autopkgtest
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/botch.git/
+Vcs-Git: git://anonscm.debian.org/collab-maint/botch.git
 
 Package: botch
 Architecture: any
@@ -38,8 +41,8 @@
  ${misc:Depends},
  ${shlibs:Depends},
  ${python3:Depends},
- dose-builddebcheck (>= 3.2.2),
- dose-extra (>= 3.2.2),
+ dose-builddebcheck (>= 3.3),
+ dose-extra (>= 3.3),
  dctrl-tools,
  aspcud,
  python3-apt,
@@ -52,9 +55,10 @@
  libjs-jquery-tablesorter,
  libjs-jquery
 # devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
-# needed by botch-cross-problems because there is no soap module for python3
+# needed by botch-dose2html because there is no soap module for python3
 Suggests:
  devscripts,
+ www-browser,
  libsoap-lite-perl
 Description: Bootstrapping helper
  Botch stands for bootstrap/build ordering tool chain and allows one to create

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with python3,ocaml

# not stripping binaries as this will lead to random segfaults
override_dh_strip:

## botch 0.16

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.6
+VERSION=0.16
 
 BIN_OPT:= \
   create-graph.native \
@@ -6,7 +6,6 @@
   bin2src.native \
   src2bin.native \
   build-fixpoint.native \
-  build-closure.native \
   clean-repository.native \
   buildgraph2srcgraph.native \
   annotate-strong.native \
@@ -21,7 +20,7 @@
 BIN_BYTE:=$(patsubst %.native, %.d.byte, $(BIN_OPT))
 BIN_PROF:=$(patsubst %.native, %.p.native, $(BIN_OPT))
 
-BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py,$(wildcard tools/*.py)))
+BIN_PYTOOLS:=$(patsubst tools/%.py, %, $(filter-out tools/util.py tools/debarch.py,$(wildcard tools/*.py)))
 BIN_OCTOOLS:=$(patsubst %.native, %, $(BIN_OPT))
 BIN_SHTOOLS:=$(patsubst tools/%.sh, %, $(wildcard tools/*.sh))
 
@@ -34,7 +33,15 @@
 BUILD = $(PWD)/dose/_build
 DOSELIBS = $(PWD)/dose/_build/dose3
 CUDFLIBS = $(PWD)/dose/_build/cudf
-DOSEBYTELIBS = common/common.cma deb/debian.cma rpm/rpm.cma opencsw/csw.cma eclipse/eclipse.cma algo/algo.cma doseparse/boilerplateNoRpm.cma doseparse/boilerplate.cma
+DOSEBYTELIBS = \
+  _build/doselibs/common.cma \
+  _build/doselibs/debian.cma \
+  _build/doselibs/versioning.cma \
+  _build/doselibs/csw.cma \
+  _build/doselibs/pef.cma \
+  _build/doselibs/algo.cma \
+  _build/doselibs/doseparse.cma \
+  _build/doselibs/doseparseNoRpm.cma
 CFLAGS=-cflags "-w +a-4-9"
 bindir=/usr/bin
 datadir=/usr/share/botch
@@ -48,7 +55,8 @@
 #   http://bugs.debian.org/778373
 export PYTHONHASHSEED=0
 # to make the sort order in the tests locale independent
-export LC_COLLATE=C
+export LC_COLLATE=C.UTF8
+export LC_ALL=C.UTF8
 # because dose2html outputs utf8 on standard output
 export PYTHONIOENCODING=utf-8
 
@@ -80,17 +88,19 @@
 
 .PHONY: doselib
 doselib:
-	(cd dose && ./configure --with-zip --with-bz2 --with-ocamlgraph --without-libcudf && make clean fast $(DOSEBYTELIBS))
+	(cd dose && ./configure --with-zip --with-bz2 --with-ocamlgraph --without-libcudf && make clean libs $(DOSEBYTELIBS))
 	rm -Rf $(DOSELIBS)
 	mkdir -p $(DOSELIBS)
 	cp dose/META $(DOSELIBS)
-	for i in dose/_build/*/common.* \
+	for i in \
+		dose/_build/*/common.* \
+		dose/_build/*/versioning.* \
 		dose/_build/*/debian.* \
 		dose/_build/*/algo.* \
 		dose/_build/*/csw.* \
-		dose/_build/*/eclipse.* \
-		dose/_build/*/boilerplate.* \
-		dose/_build/*/boilerplateNoRpm.*; do \
+		dose/_build/*/pef.* \
+		dose/_build/*/doseparseNoRpm.* \
+		dose/_build/*/doseparse.*; do \
 	  if [ -e $$i ]; then \
 	  cp $$i $(DOSELIBS) ; \
 	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
@@ -116,72 +126,75 @@
 .PHONY: atdgen
 atdgen: datatypes_j.ml datatypes_t.ml
 
+# the "while : ; do" loop around graph-difference is a temporary fix to work
+# around random segmentation faults. See http://bugs.python.org/issue24605
 .PHONY: test-default
-test-default: all
+test-default: $(OCAML_BEST)
 	rm -rf tmp out
-	./tools/native.sh --debug --verbose --develop --output out --tmp tmp amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --jobs=2 --drop-b-d-indep amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/default/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
+		*.xml) while : ; do ./tools/graph-difference.py "tests/default/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/default/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/default/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/default/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/default/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/default/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
 .PHONY: test-selfcontained
-test-selfcontained: all
+test-selfcontained: $(OCAML_BEST)
 	rm -rf tmp out
-	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --latest --clean --self-contained --optuniv --sapsb --strong --no-drop amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/native.sh --debug --verbose --develop --output out --tmp tmp --drop-b-d-indep --optgraph --latest --clean --self-contained --optuniv --sapsb --strong --no-drop amd64 tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/selfcontained/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/selfcontained/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/selfcontained/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/selfcontained/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/selfcontained/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/selfcontained/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
 .PHONY: test-cross
-test-cross: all
+test-cross: $(OCAML_BEST)
 	rm -rf tmp out
 	mkdir out
 	cp tests/cross-ma.diff out/ma.diff
-	./tools/cross.sh --debug --verbose --develop --output=out --tmp=tmp amd64 armhf tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
+	./tools/cross.sh --debug --verbose --develop --output=out --tmp=tmp --drop-b-d-indep --optgraph --jobs=2 amd64 armhf tests/sid-amd64-packages-20140101T000000Z tests/sid-sources-20140101T000000Z
 	for f in tests/cross/tmp/* tmp/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/cross/tmp/$$f" "tmp/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/cross/tmp/$$f" "tmp/$$f" || exit 1;; \
 		esac; \
 	done
 	for f in tests/cross/out/* out/*; do basename "$$f"; done | sort | uniq | while read f; do \
 		echo checking $$f; \
 		case "$$f" in \
-			*.xml) ./tools/graph-difference.py "tests/cross/out/$$f" "out/$$f" || exit 1;; \
+			*.xml) while : ; do ./tools/graph-difference.py "tests/cross/out/$$f" "out/$$f"; exit=$$?; if [ $$exit -eq 139 ]; then echo segfault; continue; fi; if [ $$exit -ne 0 ]; then exit 1; else break; fi; done;; \
 			*) diff -u "tests/cross/out/$$f" "out/$$f" || exit 1;; \
 		esac; \
 	done
 
-.PHONY: test
-test: test-default test-selfcontained test-cross
+.PHONY: test-man
+test-man: all
 	# test whether there is no manpage without a program by
 	# normalizing program and manpage names and only printing
 	# those names which are not duplicate but unique
 	ls tools/*.py *.$(OCAML_BEST) tools/*.sh doc/man/botch-*.pod \
 		| grep -v tools/util.py \
+		| grep -v tools/debarch.py \
 		| while read pkg; do \
 			pkg=`basename $$pkg .$(OCAML_BEST)`; \
 			pkg=`basename $$pkg .py`; \
@@ -192,12 +205,47 @@
 			echo doc/man/botch-$${pkg}.pod is superfluous >&2; \
 			exit 1; \
 		done
+	# now that we know that there is one man page for every program, check
+	# whether the man page documents all the program options
+	ls tools/*.py *.$(OCAML_BEST) tools/*.sh \
+		| grep -v tools/util.py \
+		| grep -v tools/debarch.py \
+		| grep -v buildcheck-more-problems | grep -v distcheck-more-problems \
+		| while read pkg; do \
+			shortopts=`./$$pkg --help 2>&1 | sed -ne 's/^ \+-\([^ =-]\).*$$/\1/p' | sort`; \
+			longopts=`./$$pkg --help 2>&1 | sed -ne 's/^ \+\(-[^ =-]\+,\)\? --\([^ =]\+\)\([ =].*\)\?$$/\2/p' | sort`; \
+			echo "compare \`./$$pkg --help\` with man page..."; \
+			man=`basename $$pkg .$(OCAML_BEST)`; \
+			man=`basename $$man .py`; \
+			man=`basename $$man .sh`; \
+			man=`basename $$man .pod`; \
+			longman=`sed -ne 's/=item B<[^>]*--\([^>=]\+\)=\?>.*$$/\1/p' doc/man/botch-$${man}.pod | sort`; \
+			shortman=`sed -ne 's/=item B<-\([^>,-]\)[^>]*>.*$$/\1/p' doc/man/botch-$${man}.pod | sort`; \
+			if [ "$$shortopts" != "$$shortman" ]; then \
+				echo "\`./$$pkg --help\` and man page ./$$man disagree:"; \
+				echo "$$shortopts != $$shortman"; \
+				exit 1; \
+			fi; \
+			if [ "$$longopts" != "$$longman" ]; then \
+				echo "\`./$$pkg --help\` and man page ./$$man disagree:"; \
+				echo "$$longopts != $$longman"; \
+				exit 1; \
+			fi; \
+		done
+
+.PHONY: test-python
+test-python:
 	# FIXME: add more tests
 	#./tests.py
 	#OCAMLPATH=$(BUILD) ocamlbuild -classic-display -use-ocamlfind $(CFLAGS) tests.$(OCAML_BEST)
 	#./tests.$(OCAML_BEST)
 	pyflakes3 tools/*.py
-	pep8 tools/*.py
+	# E402 is triggered by the sys.path.append() statement in front of import of utils
+	# see https://github.com/PyCQA/pep8/issues/264
+	pep8 --ignore=E402 tools/*.py
+
+.PHONY: test
+test: test-python test-man test-default test-selfcontained test-cross
 
 .PHONY: install
 install: all
@@ -215,6 +263,7 @@
 	mkdir -p $(DESTDIR)$(datadir)
 	cp -r droppable $(DESTDIR)$(datadir)
 	cp tools/util.py $(DESTDIR)$(datadir)
+	cp tools/debarch.py $(DESTDIR)$(datadir)
 
 .PHONY: clean
 clean:
@@ -223,8 +272,11 @@
 	rm -f tools/*.pyc
 	rm -f *.native *.d.byte
 	rm -f doc/man/*.1
+	$(MAKE) -C doc/wiki clean
+
+.PHONY: distclean
+distclean: clean
 	rm -rf tools/__pycache__ tmp out
-	$(MAKE) -C doc/wiki clean
 
 .PHONY: doseclean
 doseclean:

=== debian/changelog ===
botch (0.16-2ubuntu2) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 05 Nov 2015 16:40:35 -0600

botch (0.16-2ubuntu1) wily; urgency=medium

  * Ignore the test results, don't run the autopkg tests. According to
    upstream, there is some dependency of botch that leads to some reordering
    somewhere in the expected test outputs.  Just adjusting the expected
    test results is not an option for now. Find the real issue ...

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Oct 2015 23:39:59 +0200

botch (0.16-2) unstable; urgency=medium

  * fix build problem on 32bit architectures

 -- Johannes Schauer <josch@debian.org>  Sun, 27 Sep 2015 13:20:46 +0200

botch (0.16-1) unstable; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 19:28:51 +0200

botch (0.15-4) unstable; urgency=medium

  * and another one...

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 16:10:02 +0200

botch (0.15-3) unstable; urgency=medium

  * another dgit test upload

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 16:02:40 +0200

botch (0.15-2) unstable; urgency=medium

  * dgit test upload

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 14:08:42 +0200

botch (0.15-1) unstable; urgency=medium

  * New upstream release (Closes: #797453)
  * bump dependency on dose tools >= 4.0.1-2
  * remove dependency on jq because it's not needed anymore due to new dose
    tools
  * update botch package description
  * update Vcs-* fields to use dgit

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Sep 2015 08:48:32 +0200

botch (0.14-1) unstable; urgency=medium

  * New upstream release
  * refresh patch send-keepalive
  * botch binary: add dependency on python3-pydot, zutils and suggest
    libgraph-easy-perl, jq
  * update debian/tests/* with --drop-b-d-indep argument and correct locale
    environment variable export
  * make debian/tests/* more readable by splitting long lines
  * update debian/tests/* with workaround for random segmentation faults
    see http://bugs.python.org/issue24605

 -- Johannes Schauer <josch@debian.org>  Wed, 29 Jul 2015 10:10:38 +0200

botch (0.13-1) unstable; urgency=medium

  * New upstream release (closes: #784835)
  * Remove the XS-Testsuite field from d/control to fix lintian warning
    xs-testsuite-header-in-debian-control

 -- Johannes Schauer <josch@debian.org>  Sun, 07 Jun 2015 12:17:15 +0200

botch (0.12-1) unstable; urgency=medium

  * New upstream release (closes: #764704)

 -- Johannes Schauer <josch@debian.org>  Wed, 03 Jun 2015 20:58:37 +0200

botch (0.11-2) unstable; urgency=medium

  * fix last d/changelog entry to say unstable instead of UNRELEASED
    uploads like this should be rejected in the first place. See #647028

 -- Johannes Schauer <josch@debian.org>  Thu, 07 May 2015 08:10:33 +0200

botch (0.11-1) unstable; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Wed, 06 May 2015 07:52:20 +0200

botch (0.10-1~experimental1) experimental; urgency=medium

  * New upstream release
  * bump dependency on libdose to 3.3-2 because of its backported fixes for
    fd-leakage and storing the original Debian package name as a cudf_extras
    field

 -- Johannes Schauer <josch@debian.org>  Fri, 27 Mar 2015 12:07:59 +0100

botch (0.9-1~experimental1) experimental; urgency=medium

  * New upstream release
  * add build dependency on libparmap-ocaml-dev

 -- Johannes Schauer <josch@debian.org>  Mon, 23 Mar 2015 21:34:37 +0100

botch (0.8-1~experimental1) experimental; urgency=medium

  * New upstream release

 -- Johannes Schauer <josch@debian.org>  Fri, 20 Mar 2015 17:08:34 +0100

botch (0.7-1~experimental1) experimental; urgency=medium

  * New upstream release
  * replace gitorious upstream url with gitlab.mister-muffin.de

 -- Johannes Schauer <josch@debian.org>  Fri, 20 Mar 2015 08:17:29 +0100

=== debian/control ===
Source: botch
Section: utils
Priority: optional
Maintainer: Johannes Schauer <josch@debian.org>
Homepage: https://gitlab.mister-muffin.de/debian-bootstrap/botch/wikis/home
Standards-Version: 3.9.6
# all build dependencies after the *-dev dependencies are only needed to run
# the testsuite
Build-Depends:
 debhelper (>= 9),
 dh-ocaml,
 ocaml-nox,
 cppo,
 python3,
 graphviz,
 markdown,
 ocaml-findlib,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev,
 libatdgen-ocaml-dev,
 libxmlm-ocaml-dev,
 libparmap-ocaml-dev,
 libdose3-ocaml-dev (>= 4.0.1-2),
 dose-builddebcheck (>= 4.0.1-2),
 dose-extra (>= 4.0.1-2),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml,
 pep8,
 pyflakes
Vcs-Browser: https://browse.dgit.debian.org/botch.git/
Vcs-Git: https://git.dgit.debian.org/dgit

Package: botch
Architecture: any
# networkx can also use python3-pygraphviz but that seems to be orders of
# magnitude slower than python3-pydot which networkx can also use to read/write
# dot graphs
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 dose-builddebcheck (>= 3.3),
 dose-extra (>= 3.3),
 dctrl-tools,
 aspcud,
 python3-apt,
 python3-debian,
 python3-networkx,
 python3-yaml,
 python3-pydot,
 zutils
# libjs-jquery-tablesorter and libjs-jquery are needed to look at the generated
# HTML with javascript bling
Recommends:
 libjs-jquery-tablesorter,
 libjs-jquery
# devscripts and libsoap-lite-perl are needed for /usr/bin/bts which is in turn
# needed by botch-dose2html because there is no soap module for python3
# libgraph-easy-perl is only needed for its /usr/bin/graph-easy program which
# is used in y-u-no-bootstrap and y-u-b-d-transitive-essential (but optional)
Suggests:
 libgraph-easy-perl,
 devscripts,
 www-browser,
 libsoap-lite-perl,
Description: Bootstrapping helper
 botch is a collection of tools to create and analyze dependency graphs. This
 task is facilitated by a range of individual tools which use the deb822 and
 graphml formats to exchange information with each other. Also consider
 browsing the HTML based doc-base Manual at /usr/share/doc/botch/wiki/Home.html
 .
 The tools that botch ships allow one to:
 .
  - analyze graphs
     - botch-calcportsmetric: calculate source package importance
     - botch-calculate-fas: calculate a feedback arc set
     - botch-find-fvs: calculate a feedback vertex set
     - botch-graph-difference: graph diff
     - botch-graph-info: show info about a buildgraph or sourcegraph
     - botch-partial-order: calculate the partial vertex order
     - botch-print-stats: find cycles, selfcycles, amount of cycles through edges, feedback arc and vertex set, strong
     - articulation points and bridges
     - botch-multiarch-interpreter-problem: find all arch:all packages that allow switching architectures
  - transform Packages and Sources control files
     - botch-latest-version: only keep the latest version
     - botch-bin2src: convert binary packages to their source packages
     - botch-src2bin: turn source packages into their binary packages
     - botch-clean-repository: clean errors in a repository by removing transitively uninstallable or compilable packages
     - botch-add-arch: add architecture to source packages
     - botch-convert-arch: convert the architecture of a Packages file
     - botch-remove-virtual-disjunctions: remove virtual dependency disjunctions
     - botch-optuniv: self contained repository with minimal number of source packages
     - botch-fix-cross-problems: fix Packages files with the output of botch-cross-problems
     - botch-filter-src-builds-for: filter a Sources file for the packages building for a certain architecture
  - create graphs of different types
     - botch-create-graph: create graph based on installation sets, strong dependency sets or dependency closures
     - botch-annotate-strong: add strong dependency information to a dependency graph
  - analysis of Packages and Sources control files
     - botch-packages-diff: create a diff between two Packages or Sources files
     - botch-ma-diff: diff two packages files for differences in their multiarch values
     - botch-apply-ma-diff: applies a multiarch diff as created by botch-ma-diff
     - botch-check-ma-same-versions: check if Multi-Arch:same versions are in sync
  - handling of botch-internal formats
     - botch-stat-html: turn the JSON output of botch-print-stats into human readable HTML
     - botch-droppable-diff: difference between two *.droppable files
     - botch-droppable-union: union of two *.droppable files
     - botch-checkfas: check which edges in the fas are not droppable
     - botch-fasofstats: extract feedback arc set from output of botch-print-stats
     - botch-download-pkgsrc: download Packages and Sources
  - dose3 wrappers
     - botch-dose2html: turn the yaml output by dose-builddebcheck into html
     - botch-buildcheck-more-problems: a tool like dose-builddebcheck but return more than the first reason
     - botch-distcheck-more-problems: a tool like dose-distcheck but return more than the first reason
  - set operations on Packages or Sources files
     - botch-packages-difference: calculate the asymmetric set difference
     - botch-packages-intersection: calculate the set intersection
     - botch-packages-union: calculate the set union
  - create build orders
     - botch-build-fixpoint: find build order until dependency cycles occur
     - botch-build-order-from-zero: find a build order for a non-existing architecture
     - botch-wanna-build-sortblockers: importance of source packages for ports
  - conversion of graphs
     - botch-buildgraph2srcgraph: converts a buildgraph into a srcgraph
     - botch-graphml2dot: converts graphml to dot
     - botch-collapse-srcgraph: make a srcgraph acyclic by collapsing its strongly connected components
     - botch-profile-build-fvs: remove droppable dependencies from graph
     - botch-buildgraph2packages: convert buildgraph to packages
     - botch-graph-tred: find the transitive reduction of a graph in GraphML or dot format
     - botch-graph2text: for each vertex in a graph print a formatted line on standard output
  - shell scripts connecting the tools for meaningful operations
     - botch-cross: execute botch tools in the cross phase
     - botch-native: execute botch tools in the native phase
     - botch-transition: calculate a transition order
     - botch-y-u-no-bootstrap: Find out why Debian cannot be bootstrapped.
     - botch-y-u-b-d-transitive-essential: Find out why source packages are B-D transitive essential.
  - extract regions from graphs
     - botch-graph-neighborhood: extract the neighborhood around a vertex
     - botch-extract-scc: extract all strongly connected components
     - botch-graph-ancestors: find all ancestors of a vertex in a graph in GraphML or dot format
     - botch-graph-descendants: find all descendants of a vertex in a graph in GraphML or dot format
     - botch-graph-shortest-path: find the shortest path(s) between two vertices of a graph in GraphML or dot format
     - botch-graph-sinks: find all sinks (vertices without successors) in a graph in GraphML or dot format
     - botch-graph-sources: find all sources (vertices without predecessors) in a graph in GraphML or dot format

Package: botch-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends:
Suggests:
Description: Bootstrapping helper - documentation
 Botch stands for bootstrap/build ordering tool chain and allows one to create
 and analyze bootstrapping dependency graphs, creates suggestions how to break
 dependency cycles and generates a build order.
 .
 This package contains the documentation.

=== debian/rules ===
--- 
+++ 
@@ -5,5 +5,16 @@
 %:
 	dh $@ --with python3,ocaml
 
+derivative :=   $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
+			elif dpkg-vendor --derives-from Debian; then echo Debian; \
+			else echo Unknown; fi)
+
+override_dh_auto_test:
+ifeq ($(derivative),Ubuntu)
+	-dh_auto_test
+else
+	dh_auto_test
+endif
+
 # not stripping binaries as this will lead to random segfaults
 override_dh_strip:

=== debian/tests/control ===
Tests: default selfcontained cross
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://mister-muffin.de/botch/ \./botch-([\d\.]+)\.tar\.xz
